using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Xml;


namespace CSFinancialTrendLayer
{
	/// <summary>
	/// Sample demonstrating UltraWinChart with User Layers
	/// calculated from Chart Data.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Infragistics.Win.UltraWinChart.UltraChart ultraChart1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ComboBox ddlbSecurity;
		private System.Windows.Forms.Button btnOpen;
		private System.Windows.Forms.Panel panelLoad;

		private System.Windows.Forms.ContextMenu ctxtMenu;

		private System.Windows.Forms.MenuItem menuStripLines;

		private System.Windows.Forms.MenuItem menuScaleType;
		private System.Windows.Forms.MenuItem menuLinear;
		private System.Windows.Forms.MenuItem menuLog;
		
		private System.Windows.Forms.MenuItem menuOverlays;
		private System.Windows.Forms.MenuItem menu5SMA;
		private System.Windows.Forms.MenuItem menu10SMA;
		private System.Windows.Forms.MenuItem menu20SMA;

		// These values must be in 1:1 correspondence to the MenuItem.Index
		// of each item on the popup Overlay menu.
		private static int[] overlayTrendLength = { 5, 10, 20};
		private static string[] overlayTrendLayerIDs = { "MultiLayer", "Default", "0_TrendLayer", "1_TrendLayer", "2_TrendLayer" };

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private bool isLogarithmic;
		private bool showingStripes;
		private OverlayTypes overlays;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InitializeCascade();
			this.isLogarithmic = false;
			this.showingStripes = true;
			this.menuStripLines.Checked = true;
			this.overlays = OverlayTypes.None;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.ultraChart1 = new Infragistics.Win.UltraWinChart.UltraChart();
			this.label1 = new System.Windows.Forms.Label();
			this.ddlbSecurity = new System.Windows.Forms.ComboBox();
			this.btnOpen = new System.Windows.Forms.Button();
			this.panelLoad = new System.Windows.Forms.Panel();
			this.panelLoad.SuspendLayout();
			this.SuspendLayout();
			// 
			// ultraChart1
			// 
			this.ultraChart1.AutoScrollMargin = new System.Drawing.Size(0, 0);
			this.ultraChart1.AutoScrollMinSize = new System.Drawing.Size(0, 0);
			this.ultraChart1.Axis.X.Labels.HorizontalAlign = System.Drawing.StringAlignment.Near;
			this.ultraChart1.Axis.X.Labels.ItemFormat = Infragistics.UltraChart.Shared.Styles.AxisItemLabelFormat.Custom;
			this.ultraChart1.Axis.X.Labels.ItemFormatString = "<ITEM_LABEL:MM-dd-yy>";
			this.ultraChart1.Axis.X.Labels.Orientation = Infragistics.UltraChart.Shared.Styles.TextOrientation.VerticalLeftFacing;
			this.ultraChart1.Axis.X.Labels.VerticalAlign = System.Drawing.StringAlignment.Center;
			this.ultraChart1.Axis.X.ScrollScale.Height = 10;
			this.ultraChart1.Axis.X.ScrollScale.Visible = true;
			this.ultraChart1.Axis.X.ScrollScale.Width = 20;
			this.ultraChart1.Axis.X.StripLines.Interval = 5;
			this.ultraChart1.Axis.X.StripLines.PE.ElementType = Infragistics.UltraChart.Shared.Styles.PaintElementType.Gradient;
			this.ultraChart1.Axis.X.StripLines.PE.Fill = System.Drawing.Color.Bisque;
			this.ultraChart1.Axis.X.StripLines.PE.FillGradientStyle = Infragistics.UltraChart.Shared.Styles.GradientStyle.Vertical;
			this.ultraChart1.Axis.X.StripLines.PE.FillImage = null;
			this.ultraChart1.Axis.X.StripLines.PE.FillStopColor = System.Drawing.Color.LightSkyBlue;
			this.ultraChart1.Axis.X.StripLines.PE.ImageFitStyle = Infragistics.UltraChart.Shared.Styles.ImageFitStyle.Tiled;
			this.ultraChart1.Axis.X.StripLines.Visible = true;
			this.ultraChart1.Axis.X.TickmarkInterval = 0;
			this.ultraChart1.Axis.X2.Labels.HorizontalAlign = System.Drawing.StringAlignment.Near;
			this.ultraChart1.Axis.X2.Labels.ItemFormat = Infragistics.UltraChart.Shared.Styles.AxisItemLabelFormat.Custom;
			this.ultraChart1.Axis.X2.Labels.ItemFormatString = "<ITEM_LABEL:MM-dd-yy>";
			this.ultraChart1.Axis.X2.Labels.Orientation = Infragistics.UltraChart.Shared.Styles.TextOrientation.VerticalLeftFacing;
			this.ultraChart1.Axis.X2.Labels.VerticalAlign = System.Drawing.StringAlignment.Center;
			this.ultraChart1.Axis.X2.Labels.Visible = false;
			this.ultraChart1.Axis.X2.ScrollScale.Height = 10;
			this.ultraChart1.Axis.X2.ScrollScale.Visible = false;
			this.ultraChart1.Axis.X2.ScrollScale.Width = 20;
			this.ultraChart1.Axis.X2.TickmarkInterval = 0;
			this.ultraChart1.Axis.Y.Labels.HorizontalAlign = System.Drawing.StringAlignment.Far;
			this.ultraChart1.Axis.Y.Labels.ItemFormat = Infragistics.UltraChart.Shared.Styles.AxisItemLabelFormat.DataValue;
			this.ultraChart1.Axis.Y.Labels.ItemFormatString = "<DATA_VALUE:00.00>";
			this.ultraChart1.Axis.Y.Labels.Orientation = Infragistics.UltraChart.Shared.Styles.TextOrientation.VerticalLeftFacing;
			this.ultraChart1.Axis.Y.Labels.VerticalAlign = System.Drawing.StringAlignment.Center;
			this.ultraChart1.Axis.Y.MinorGridLines.Color = System.Drawing.Color.DarkGray;
			this.ultraChart1.Axis.Y.ScrollScale.Height = 10;
			this.ultraChart1.Axis.Y.ScrollScale.Visible = false;
			this.ultraChart1.Axis.Y.ScrollScale.Width = 20;
			this.ultraChart1.Axis.Y.TickmarkInterval = 0;
			this.ultraChart1.Axis.Y2.Labels.HorizontalAlign = System.Drawing.StringAlignment.Near;
			this.ultraChart1.Axis.Y2.Labels.ItemFormat = Infragistics.UltraChart.Shared.Styles.AxisItemLabelFormat.DataValue;
			this.ultraChart1.Axis.Y2.Labels.ItemFormatString = "<DATA_VALUE:00.00>";
			this.ultraChart1.Axis.Y2.Labels.Orientation = Infragistics.UltraChart.Shared.Styles.TextOrientation.VerticalLeftFacing;
			this.ultraChart1.Axis.Y2.Labels.VerticalAlign = System.Drawing.StringAlignment.Center;
			this.ultraChart1.Axis.Y2.Labels.Visible = false;
			this.ultraChart1.Axis.Y2.ScrollScale.Height = 10;
			this.ultraChart1.Axis.Y2.ScrollScale.Visible = false;
			this.ultraChart1.Axis.Y2.ScrollScale.Width = 20;
			this.ultraChart1.Axis.Y2.TickmarkInterval = 0;
			this.ultraChart1.Axis.Z.Labels.HorizontalAlign = System.Drawing.StringAlignment.Near;
			this.ultraChart1.Axis.Z.Labels.ItemFormat = Infragistics.UltraChart.Shared.Styles.AxisItemLabelFormat.None;
			this.ultraChart1.Axis.Z.Labels.ItemFormatString = "";
			this.ultraChart1.Axis.Z.Labels.Orientation = Infragistics.UltraChart.Shared.Styles.TextOrientation.Horizontal;
			this.ultraChart1.Axis.Z.Labels.SeriesFormatString = "";
			this.ultraChart1.Axis.Z.Labels.VerticalAlign = System.Drawing.StringAlignment.Center;
			this.ultraChart1.Axis.Z.ScrollScale.Height = 10;
			this.ultraChart1.Axis.Z.ScrollScale.Visible = false;
			this.ultraChart1.Axis.Z.ScrollScale.Width = 20;
			this.ultraChart1.Axis.Z.TickmarkInterval = 0;
			this.ultraChart1.CandleChart.NegativeRangeColor = System.Drawing.Color.Red;
			this.ultraChart1.CandleChart.PositiveRangeColor = System.Drawing.Color.Lime;
			this.ultraChart1.CandleChart.SkipN = 4;
			this.ultraChart1.CandleChart.VolumeVisible = true;
			this.ultraChart1.CandleChart.WickColor = System.Drawing.Color.Black;
			this.ultraChart1.ChartType = Infragistics.UltraChart.Shared.Styles.ChartType.CandleChart;
			this.ultraChart1.ColorModel.ColorBegin = System.Drawing.Color.Red;
			this.ultraChart1.ColorModel.ColorEnd = System.Drawing.Color.DodgerBlue;
			this.ultraChart1.ColorModel.Skin.ApplyRowWise = false;
			this.ultraChart1.Dock = System.Windows.Forms.DockStyle.Top;
			this.ultraChart1.EmptyChartText = "Please select a security to chart from the selections below, or open existing his" +
				"torical data with the Open button.";
			this.ultraChart1.Name = "ultraChart1";
			this.ultraChart1.ScrollBarImage = null;
			this.ultraChart1.Size = new System.Drawing.Size(699, 500);
			this.ultraChart1.TabIndex = 0;
			this.ultraChart1.TitleTop.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F);
			this.ultraChart1.TitleTop.HorizontalAlign = System.Drawing.StringAlignment.Center;
			this.ultraChart1.TitleTop.Text = "";
			this.ultraChart1.UserLayerIndex = null;
			// 
			// label1
			// 
			this.label1.Dock = System.Windows.Forms.DockStyle.Top;
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(699, 56);
			this.label1.TabIndex = 1;
			this.label1.Text = "Please select a security to chart from the selections below, or open existing his" +
				"torical data with the Open button.";
			// 
			// ddlbSecurity
			// 
			this.ddlbSecurity.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.ddlbSecurity.Items.AddRange(new object[] {
															  "ABCDE (ABC Diving Equipment Co.)",
															  "XYZ.OTCBB (Xaviar, Yngwee and Zapata AG)"});
			this.ddlbSecurity.Location = new System.Drawing.Point(18, 56);
			this.ddlbSecurity.Name = "ddlbSecurity";
			this.ddlbSecurity.Size = new System.Drawing.Size(508, 24);
			this.ddlbSecurity.TabIndex = 2;
			this.ddlbSecurity.Text = "ABCDE (ABC Diving Equipment Co.)";
			this.ddlbSecurity.SelectedIndexChanged += new System.EventHandler(this.ddlbSecurity_SelectedIndexChanged);
			// 
			// btnOpen
			// 
			this.btnOpen.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnOpen.Location = new System.Drawing.Point(533, 53);
			this.btnOpen.Name = "btnOpen";
			this.btnOpen.Size = new System.Drawing.Size(88, 27);
			this.btnOpen.TabIndex = 3;
			this.btnOpen.Text = "Open";
			this.btnOpen.Click += new System.EventHandler(this.btnOpen_Click);
			// 
			// panelLoad
			// 
			this.panelLoad.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.btnOpen,
																					this.ddlbSecurity,
																					this.label1});
			this.panelLoad.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.panelLoad.Location = new System.Drawing.Point(0, 505);
			this.panelLoad.Name = "panelLoad";
			this.panelLoad.Size = new System.Drawing.Size(699, 90);
			this.panelLoad.TabIndex = 4;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(699, 595);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.panelLoad,
																		  this.ultraChart1});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "Form1";
			this.Text = "Financial Trend Layer Sample";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.panelLoad.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Main entry point for the Application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}


		protected virtual void InitializeCascade()
		{
			ctxtMenu = new ContextMenu();

			menuStripLines = new MenuItem();
			menuStripLines.Index = 2;
			menuStripLines.Text = "&Strip Lines";
			menuStripLines.Checked = this.showingStripes;
			menuStripLines.Click += new EventHandler( menuStripLines_Click);

			menuLinear = new MenuItem();
			menuLinear.Index = 0;
			menuLinear.Text = "&Linear";
			menuLinear.Click += new EventHandler( menuScaleType_ChildClick);

			menuLog = new MenuItem();
			menuLog.Index = 1;
			menuLog.Text = "Lo&garithmic";
			menuLog.Click += new EventHandler( menuScaleType_ChildClick);

			menuScaleType = new MenuItem();
			menuScaleType.Index = 0;
			menuScaleType.Text = "&Chart Type";
			menuScaleType.Popup += new EventHandler( menuScaleType_Popup);
			menuScaleType.MenuItems.AddRange( new MenuItem[] { menuLinear, menuLog } );

			menu5SMA = new MenuItem();
			menu5SMA.Index = 0;
			menu5SMA.Text = "&5 Day Moving Average";
			menu5SMA.Click += new EventHandler( menuOverlays_ChildClick);

			menu10SMA = new MenuItem();
			menu10SMA.Index = 1;
			menu10SMA.Text = "&10 Day Moving Average";
			menu10SMA.Click += new EventHandler( menuOverlays_ChildClick);

			menu20SMA = new MenuItem();
			menu20SMA.Index = 2;
			menu20SMA.Text = "&20 Day Moving Average";
			menu20SMA.Click += new EventHandler( menuOverlays_ChildClick);

			menuOverlays = new MenuItem();
			menuOverlays.Index = 1;
			menuOverlays.Text = "&Overlays";
			menuOverlays.Popup += new EventHandler( menuOverlays_Popup);
			menuOverlays.MenuItems.AddRange( new MenuItem[] { menu5SMA, menu10SMA, menu20SMA });

			ctxtMenu.MenuItems.AddRange( new MenuItem[] { menuScaleType, menuOverlays, menuStripLines }	);
			ultraChart1.ContextMenu = ctxtMenu;
		}

		private void menuScaleType_Popup( object sender, EventArgs e)
		{
			if ( sender is MenuItem )
			{
				bool popupActive = ( ultraChart1.Data.DataSource != null );
				foreach ( MenuItem mi in ((Menu)sender).MenuItems)
				{
					mi.Enabled = popupActive;
					mi.Checked = ( (isLogarithmic ? 1 : 0) == mi.Index);
				}
			}
		}

		private void menuScaleType_ChildClick( object sender, EventArgs e)
		{
			if ( sender is MenuItem )
			{
				MenuItem mi = (MenuItem) sender;

				// Click Linear & scale is Log, or click Log & scale is Linear.
				if ( ( mi.Index == 1 ) ^ ( isLogarithmic ) )
				{
					isLogarithmic = !isLogarithmic;

					if ( isLogarithmic )
					{
						// Set ultraChart1.Axis.Y scale Natural Logarithmic (base 2.718...)
						ultraChart1.Axis.Y.NumericAxisType = Infragistics.UltraChart.Shared.Styles.NumericAxisType.Logarithmic;
						ultraChart1.Axis.Y.LogBase = System.Math.E;

						// Set ultraChart1.Axis.Y.Labels items on major logarithmic gridlines.
						ultraChart1.Axis.Y.MinorGridLines.Visible = true;
						ultraChart1.Axis.Y.Labels.ItemFormatString = "atmajor(<DATA_VALUE:##.##>)";
						ultraChart1.Axis.Y.Labels.Visible = true;
					}
					else
					{
						// Set ultraChart1.Axis.Y scale Linear.
						ultraChart1.Axis.Y.NumericAxisType = Infragistics.UltraChart.Shared.Styles.NumericAxisType.Linear;
						ultraChart1.Axis.Y.Labels.ItemFormatString = "<DATA_VALUE:##.##>";
						ultraChart1.Axis.Y.MinorGridLines.Visible = false;	// Default
					}

					ultraChart1.InvalidateLayers();
				}
			}
		}

		private void menuOverlays_Popup( object sender, EventArgs e)
		{
			if ( sender is MenuItem )
			{
				bool popupActive = ( ultraChart1.Data.DataSource != null );
				foreach ( MenuItem mi in ((Menu)sender).MenuItems)
				{
					mi.Enabled = popupActive;
					mi.Checked = ( ((int)(overlays)) & ( 1 << mi.Index ) ) != 0;
				}
			}
		}

		private void menuOverlays_ChildClick( object sender, EventArgs e)
		{
			if ( sender is MenuItem )
			{
				try
				{
					MenuItem mi = (MenuItem) sender;
					int flagBit = (1 << mi.Index);

					overlays = overlays ^ (OverlayTypes) flagBit;

					// Activate or deactivate the specified overlay layer.
					if ( ( (int)( overlays) & flagBit ) == flagBit )
					{
						// Turned ON, so insert Layer.
						this.InsertLayer( 
							String.Format( 
								"{0}_TrendLayer",
								mi.Index
							),
							new TrendLayer(
								Form1.overlayTrendLength[ mi.Index]
							)
						);
					}
					else
					{
						// Turned OFF, so remove Layer.
						this.RemoveLayer(
							String.Format(
								"{0}_TrendLayer",
								mi.Index
							)
						);
					}
				}
				catch ( Exception)
				{
					// Additional menu item added? Disregard.
					;
				}
			}
		}

		private void menuStripLines_Click( object sender, EventArgs e)
		{
			if ( sender is MenuItem )
			{
				MenuItem mi = (MenuItem) sender;

				this.showingStripes = !this.showingStripes;
				mi.Checked = this.showingStripes;

				if ( this.showingStripes )
				{
					// Show strip lines every five data points (weekly) with a dawn sky gradient
					// and then set their Visibility to true.
					this.ultraChart1.Axis.X.StripLines.Interval = 5;
					this.ultraChart1.Axis.X.StripLines.PE = new Infragistics.UltraChart.Resources.Appearance.PaintElement( Color.Bisque, Color.LightSkyBlue, Infragistics.UltraChart.Shared.Styles.GradientStyle.Vertical);
					this.ultraChart1.Axis.X.StripLines.Visible = true;
				}
				else
				{
					// Hide strip lines by setting their Visibility to false.
					this.ultraChart1.Axis.X.StripLines.Visible = false;
				}

				this.ultraChart1.InvalidateLayers();
			}
		}

		private void ddlbSecurity_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			int selIndex = this.ddlbSecurity.SelectedIndex;

			switch ( selIndex )
			{
				case 0:
					// Load hypothetical numbers for a fictitious ticker, ABCDE
					this.DefaultDataBind();
					break;

				case 1:
					// Load hypothetical numbers for a fictitious XYZ ADR trading over the OTCBB
					ultraChart1.Data.DataSource = @"..\Data\xyz.xml";
					ultraChart1.TitleTop.Text = "XYZ.OTCBB (Xaviar, Yngwee and Zapata AG)";
					ultraChart1.Data.DataBind();
					break;

				default:
					break;
			}
		}

		private void btnOpen_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog fileDlg = new OpenFileDialog();

			fileDlg.InitialDirectory = System.Environment.CurrentDirectory + @"..\..\..\..\Data";
			fileDlg.Filter = "XML files (*.xml)|*.xml|All files (*.*)|*.*";
			fileDlg.FilterIndex = 2;
			fileDlg.RestoreDirectory = true;

			if ( DialogResult.OK == fileDlg.ShowDialog())
			{
				ultraChart1.Data.DataSource = fileDlg.FileName;
				ultraChart1.Data.DataBind();
			}
		}

		private void InsertLayer( string name, Infragistics.UltraChart.Core.Layers.ILayer layerImpl)
		{
			layerImpl.LayerID = name;
			layerImpl.Visible = true;
			this.ultraChart1.Layer.Add( name, layerImpl);
			this.ultraChart1.UserLayerIndex = Form1.overlayTrendLayerIDs;
			this.ultraChart1.InvalidateLayers();
		}

		private void DefaultDataBind()
		{
			ultraChart1.Data.DataSource = @"..\abcde.xml";
			ultraChart1.TitleTop.Text = "ABCDE (ABC Diving Equipment Co.)";
			ultraChart1.Data.DataBind();
		}


		private void RemoveLayer( string name)
		{
			this.ultraChart1.Layer.Remove( name);
			this.ultraChart1.InvalidateLayers();
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.DefaultDataBind();
		}

		#region "Alternate Bind to XML (Not Used)"
/*
		// Use this approach for adapting arbitrary XML instances into an acceptable DataTable for CandleChart.
		// The default XML binding (used by this Sample) relies on the XML possessing a schema.
		// See the XML import files in /Data.
		//
		private void BindToXml( string xmlFilename)
		{
			DataTable table = new DataTable( "Quotes");
			DataColumn cDate = new DataColumn("Date", typeof(DateTime));
			DataColumn cOpen = new DataColumn("Open", typeof(double));
			DataColumn cHigh = new DataColumn("High", typeof(double));
			DataColumn cLow = new DataColumn("Low", typeof(double));
			DataColumn cClose = new DataColumn("Close", typeof(double));
			DataColumn cVolume = new DataColumn("Volume", typeof(int));
			DataRow nextRow;

			table.Columns.Add( cDate);
			table.Columns.Add( cOpen);
			table.Columns.Add( cHigh);
			table.Columns.Add( cLow);
			table.Columns.Add( cClose);
			table.Columns.Add( cVolume);

			XmlDocument doc = new XmlDocument();
			doc.Load( xmlFilename);
			XmlNodeList quotes = doc.GetElementsByTagName("quote");
			foreach ( XmlNode q in quotes )
			{
				try
				{
					XmlElement e = (q as XmlElement);
					nextRow = table.NewRow();
					nextRow[0] = DateTime.Parse(e.SelectSingleNode("date").InnerXml);
					nextRow[1] = Double.Parse( e.SelectSingleNode("open").Value);
					nextRow[2] = Double.Parse( e.SelectSingleNode("high").Value);
					nextRow[3] = Double.Parse( e.SelectSingleNode("low").Value);
					nextRow[4] = Double.Parse( e.SelectSingleNode("close").Value);
					nextRow[5] = Int32.Parse( e.SelectSingleNode("vol").Value);
					table.Rows.Add( nextRow);
				}
				catch
				{
					;
				}
			}
			ultraChart1.Data.DataSource = table;
			ultraChart1.Data.DataBind();
		}
*/
		#endregion
	}

	[Flags] public enum OverlayTypes
	{
		None = 0,
		SMA5 = 1,
		SMA10 = 2,
		SMA20 = 4
	}
}
